{$A+,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 65520,0,655360}
program trip;

type
   Tnode = record
      f, v: byte; w: integer;
   end;
   Tsol = array[1..200] of byte;

var
   n, i: byte;
   d: array[1..100, 1..100] of integer;
   l: array[1..100] of integer;
   from: array[1..100] of byte;
   tail: integer;
   q: array[0..10000] of ^Tnode;
   sollen: integer;
   soln: byte;
   sol: Tsol;


procedure readinputs;
var
   fp: text;
   m, i, j, x, y, w: integer;
begin
   for i := 1 to 100 do for j := 1 to 100 do d[i, j] := -1;
   assign(fp, 'TRIP.IN');
   reset(fp);
   readln(fp, n, m);
   for i := 1 to m do
   begin
      readln(fp, x, y, w);
      if (w < d[x, y]) or (d[x, y] < 0) then begin d[x, y] := w; d[y, x] := w; end;
   end;
   close(fp);
end;


procedure init;
begin
   for tail := 0 to 10000 do q[tail] := nil;
   tail := 0;
end;


procedure put(f, v: byte; w: integer);
var
   i: integer;
begin
   inc(tail); new(q[tail]);
   i := tail;
   while (i > 1) and (q[i div 2]^.w > w) do
   begin
      q[i]^ := q[i div 2]^;
      i := i div 2;
   end;
   q[i]^.f := f; q[i]^.v := v; q[i]^.w := w;
end;


procedure get(var f, v: byte; var w: integer);
var
   i, j: integer;
begin
   f := q[1]^.f; v := q[1]^.v; w := q[1]^.w;
   i := 1; j := 2;
   while ((q[j] <> nil) and (q[j]^.w < q[tail]^.w)) or ((q[j+1] <> nil) and (q[j+1]^.w < q[tail]^.w)) do
   begin
      if q[j+1]^.w < q[j]^.w then inc(j);
      q[i]^ := q[j]^;
      i := j; j := 2*i;
   end;
   q[i]^ := q[tail]^;
   dispose(q[tail]); q[tail] := nil;
   dec(tail);
end;


procedure check(f, v: byte; w: integer);
var
   ok: boolean;
   p: Tsol;
   i, left, right: byte;
   was: array[1..100] of boolean;
begin
   if l[v]+w < sollen then
   begin
      i := v; left := 100;
      repeat
         p[left] := i; dec(left);
         i := from[i];
      until i = from[i];
      p[left] := i;
      i := f; right := 101;
      repeat
         p[right] := i; inc(right);
         i := from[i];
      until i = from[i];
      dec(right);

      fillchar(was[1], 100, false);
      ok := true;
      for i := left to right do
      begin
         if was[p[i]] then ok := false;
         was[p[i]] := true;
      end;
      if ok then
      begin
         sollen := l[v]+w; soln := right-left+1;
         for i := left to right do
            sol[i-left+1] := p[i];
      end;
   end;
end;


{normalan Dijkstrin algoritam koji kad naidje na brid koji cini ciklus
poziva proceduru check koja raspise taj ciklus i pogleda da li je on kraci
od do sada najkraceg ciklusa}
procedure find(s: byte);
var
   f, v, i: byte;
   w: integer;
   was: array[1..100] of boolean;
begin
   fillchar(was[1], 100, false);
   init;
   put(s, s, 0);
   repeat
      get(f, v, w);
      if was[v] then check(f, v, w)
      else
      begin
         was[v] := true; l[v] := w; from[v] := f;
         for i := 1 to n do
            if d[v, i] > 0 then
               if not was[i] then
                  put(v, i, w+d[v, i]);
      end;
   until tail = 0;
end;


procedure writesol;
var
   fp: text;
   i: byte;
begin
   assign(fp, 'TRIP.OUT');
   rewrite(fp);
   if soln = 0 then
      writeln(fp, 'No solution.')
   else
   begin
      for i := 1 to soln-1 do
         write(fp, sol[i], ' ');
      writeln(fp, sol[soln]);
   end;
   close(fp);
end;


begin
   readinputs;
   sollen := maxint; soln := 0;
   for i := 1 to n do find(i);
   writesol;
end.